module.exports = `Mr. Speaker, Vice President Cheney, Members of Congress, distinguished guests, and fellow citizens:
America this evening is a Nation called to great responsibilities. And we are rising to meet them.
As we gather tonight, hundreds of thousands of American servicemen and women are deployed across the world in the war on terror. By bringing hope to the oppressed, and delivering justice to the violent, they are making America more secure.
Each day, law enforcement personnel and intelligence officers are tracking terrorist threats; analysts are examining airline passenger lists; the men and women of our new Homeland Security Department are patrolling our coasts and borders. And their vigilance is protecting America.
Americans are proving once again to be the hardest working people in the world. The American economy is growing stronger. The tax relief you passed is working.
Tonight, Members of Congress can take pride in great works of compassion and reform that skeptics had thought impossible. You are raising the standards of our public schools; and you are giving our senior citizens prescription drug coverage under Medicare.
We have faced serious challenges together - and now we face a choice. We can go forward with confidence and resolve - or we can turn back to the dangerous illusion that terrorists are not plotting and outlaw regimes are no threat to us. We can press on with economic growth, and reforms in education and Medicare - or we can turn back to the old policies and old divisions.
We have not come all this way - through tragedy, and trial, and war - only to falter and leave our work unfinished. Americans are rising to the tasks of history, and they expect the same of us. In their efforts, their enterprise, and their character, the American people are showing that the state of our Union is confident and strong.
Our greatest responsibility is the active defense of the American people. Twenty-eight months have passed since September 11th, 2001 - over two years without an attack on American soil - and it is tempting to believe that the danger is behind us. That hope is understandable, comforting - and false. The killing has continued in Bali, Jakarta, Casablanca, Riyadh, Mombassa, Jerusalem, Istanbul, and Baghdad. The terrorists continue to plot against America and the civilized world. And by our will and courage, this danger will be defeated.
Inside the United States, where the war began, we must continue to give homeland security and law enforcement personnel every tool they need to defend us. And one of those essential tools is the PATRIOT Act, which allows Federal law enforcement to better share information, to track terrorists, to disrupt their cells, and to seize their assets. For years, we have used similar provisions to catch embezzlers and drug traffickers. If these methods are good for hunting criminals, they are even more important for hunting terrorists. Key provisions of the PATRIOT Act are set to expire next year. The terrorist threat will not expire on that schedule. Our law enforcement needs this vital legislation to protect our citizens - you need to renew the PATRIOT Act.
America is on the offensive against the terrorists who started this war. Last March, Khalid Shaikh Mohammed, a mastermind of September 11th, awoke to find himself in the custody of U.S. and Pakistani authorities. Last August 11th brought the capture of the terrorist Hambali, who was a key player in the attack in Indonesia that killed over 200 people. We are tracking al-Qaida around the world - and nearly two-thirds of their known leaders have now been captured or killed. Thousands of very skilled and determined military personnel are on a manhunt, going after the remaining killers who hide in cities and caves - and, one by one, we will bring the terrorists to justice.
As part of the offensive against terror, we are also confronting the regimes that harbor and support terrorists, and could supply them with nuclear, chemical, or biological weapons. The United States and our allies are determined: We refuse to live in the shadow of this ultimate danger.
The first to see our determination were the Taliban, who made Afghanistan the primary training base of al-Qaida killers. As of this month, that country has a new constitution, guaranteeing free elections and full participation by women. Businesses are opening, health care centers are being established, and the boys and girls of Afghanistan are back in school. With help from the new Afghan Army, our coalition is leading aggressive raids against surviving members of the Taliban and al-Qaida. The men and women of Afghanistan are building a nation that is free, and proud, and fighting terror - and America is honored to be their friend.
Since we last met in this chamber, combat forces of the United States, Great Britain, Australia, Poland, and other countries enforced the demands of the United Nations, ended the rule of Saddam Hussein - and the people of Iraq are free. Having broken the Baathist regime, we face a remnant of violent Saddam supporters. Men who ran away from our troops in battle are now dispersed and attack from the shadows.
These killers, joined by foreign terrorists, are a serious, continuing danger. Yet we are making progress against them. The once all-powerful ruler of Iraq was found in a hole, and now sits in a prison cell. Of the top 55 officials of the former regime, we have captured or killed 45. Our forces are on the offensive, leading over 1,600 patrols a day, and conducting an average of 180 raids every week. We are dealing with these thugs in Iraq, just as surely as we dealt with Saddam Hussein's evil regime.
The work of building a new Iraq is hard, and it is right. And America has always been willing to do what it takes for what is right. Last January, Iraq's only law was the whim of one brutal man. Today our coalition is working with the Iraqi Governing Council to draft a basic law, with a bill of rights. We are working with Iraqis and the United Nations to prepare for a transition to full Iraqi sovereignty by the end of June. As democracy takes hold in Iraq, the enemies of freedom will do all in their power to spread violence and fear. They are trying to shake the will of our country and our friends - but the United States of America will never be intimidated by thugs and assassins. The killers will fail, and the Iraqi people will live in freedom.
Month by month, Iraqis are assuming more responsibility for their own security and their own future. And tonight we are honored to welcome one of Iraq's most respected leaders: the current President of the Iraqi Governing Council, Adnan Pachachi. Sir, America stands with you and the Iraqi people as you build a free and peaceful nation.
Because of American leadership and resolve, the world is changing for the better. Last month, the leader of Libya voluntarily pledged to disclose and dismantle all of his regime's weapons of mass destruction programs, including a uranium enrichment project for nuclear weapons. Colonel Qadhafi correctly judged that his country would be better off, and far more secure, without weapons of mass murder. Nine months of intense negotiations involving the United States and Great Britain succeeded with Libya, while 12 years of diplomacy with Iraq did not. And one reason is clear: For diplomacy to be effective, words must be credible - and no one can now doubt the word of America.
Different threats require different strategies. Along with nations in the region, we are insisting that North Korea eliminate its nuclear program. America and the international community are demanding that Iran meet its commitments and not develop nuclear weapons. America is committed to keeping the world's most dangerous weapons out of the hands of the world's most dangerous regimes.
When I came to this rostrum on September 20th, 2001, I brought the police shield of a fallen officer, my reminder of lives that ended, and a task that does not end. I gave to you and to all Americans my complete commitment to securing our country and defeating our enemies. And this pledge, given by one, has been kept by many. You in the Congress have provided the resources for our defense, and cast the difficult votes of war and peace. Our closest allies have been unwavering. America's intelligence personnel and diplomats have been skilled and tireless.
d the men and women of the American military - they have taken the hardest duty. We have seen their skill and courage in armored charges, and midnight raids, and lonely hours on faithful watch. We have seen the joy when they return, and felt the sorrow when one is lost. I have had the honor of meeting our servicemen and women at many posts, from the deck of a carrier in the Pacific, to a mess hall in Baghdad. Many of our troops are listening tonight. And I want you and your families to know: America is proud of you. And my Administration, and this Congress, will give you the resources you need to fight and win the war on terror.
I know that some people question if America is really in a war at all. They view terrorism more as a crime - a problem to be solved mainly with law enforcement and indictments. After the World Trade Center was first attacked in 1993, some of the guilty were indicted, tried, convicted, and sent to prison. But the matter was not settled. The terrorists were still training and plotting in other nations, and drawing up more ambitious plans. After the chaos and carnage of September 11th, it is not enough to serve our enemies with legal papers. The terrorists and their supporters declared war on the United States - and war is what they got.
Some in this chamber, and in our country, did not support the liberation of Iraq. Objections to war often come from principled motives. But let us be candid about the consequences of leaving Saddam Hussein in power. We are seeking all the facts - already the Kay Report identified dozens of weapons of mass destruction-related program activities and significant amounts of equipment that Iraq concealed from the United Nations. Had we failed to act, the dictator's weapons of mass destruction programs would continue to this day. Had we failed to act, Security Council resolutions on Iraq would have been revealed as empty threats, weakening the United Nations and encouraging defiance by dictators around the world. Iraq's torture chambers would still be filled with victims - terrified and innocent. The killing fields of Iraq - where hundreds of thousands of men, women, and children vanished into the sands - would still be known only to the killers. For all who love freedom and peace, the world without Saddam Hussein's regime is a better and safer place.
Some critics have said our duties in Iraq must be internationalized. This particular criticism is hard to explain to our partners in Britain, Australia, Japan, South Korea, the Philippines, Thailand, Italy, Spain, Poland, Denmark, Hungary, Bulgaria, Ukraine, Romania, the Netherlands, Norway, El Salvador, and the 17 other countries that have committed troops to Iraq. As we debate at home, we must never ignore the vital contributions of our international partners, or dismiss their sacrifices. From the beginning, America has sought international support for operations in Afghanistan and Iraq, and we have gained much support. There is a difference, however, between leading a coalition of many nations, and submitting to the objections of a few. America will never seek a permission slip to defend the security of our people.
We also hear doubts that democracy is a realistic goal for the greater Middle East, where freedom is rare. Yet it is mistaken, and condescending, to assume that whole cultures and great religions are incompatible with liberty and self-government. I believe that God has planted in every heart the desire to live in freedom. And even when that desire is crushed by tyranny for decades, it will rise again.
As long as the Middle East remains a place of tyranny, despair, and anger, it will continue to produce men and movements that threaten the safety of America and our friends. So America is pursuing a forward strategy of freedom in the greater Middle East. We will challenge the enemies of reform, confront the allies of terror, and expect a higher standard from our friends. To cut through the barriers of hateful propaganda, the Voice of America and other broadcast services are expanding their programming in Arabic and Persian - and soon, a new television service will begin providing reliable news and information across the region. I will send you a proposal to double the budget of the National Endowment for Democracy, and to focus its new work on the development of free elections, free markets, free press, and free labor unions in the Middle East. And above all, we will finish the historic work of democracy in Afghanistan and Iraq, so those nations can light the way for others, and help transform a troubled part of the world.
America is a Nation with a mission - and that mission comes from our most basic beliefs. We have no desire to dominate, no ambitions of empire. Our aim is a democratic peace - a peace founded upon the dignity and rights of every man and woman. America acts in this cause with friends and allies at our side, yet we understand our special calling: This great Republic will lead the cause of freedom.
In these last three years, adversity has also revealed the fundamental strengths of the American economy. We have come through recession, and terrorist attack, and corporate scandals, and the uncertainties of war. And because you acted to stimulate our economy with tax relief, this economy is strong, and growing stronger.
You have doubled the child tax credit from 500 to a thousand dollars, reduced the marriage penalty, begun to phase out the death tax, reduced taxes on capital gains and stock dividends, cut taxes on small businesses, and you have lowered taxes for every American who pays income taxes.
Americans took those dollars and put them to work, driving this economy forward. The pace of economic growth in the third quarter of 2003 was the fastest in nearly 20 years. New home construction: the highest in almost 20 years. Home ownership rates: the highest ever. Manufacturing activity is increasing. Inflation is low. Interest rates are low. Exports are growing. Productivity is high. And jobs are on the rise.
These numbers confirm that the American people are using their money far better than government would have - and you were right to return it.
America's growing economy is also a changing economy. As technology transforms the way almost every job is done, America becomes more productive, and workers need new skills. Much of our job growth will be found in high-skilled fields like health care and biotechnology. So we must respond by helping more Americans gain the skills to find good jobs in our new economy.
All skills begin with the basics of reading and math, which are supposed to be learned in the early grades of our schools. Yet for too long, for too many children, those skills were never mastered. By passing the No Child Left Behind Act, you have made the expectation of literacy the law of our country. We are providing more funding for our schools - a 36 percent increase since 2001. We are requiring higher standards. We are regularly testing every child on the fundamentals. We are reporting results to parents, and making sure they have better options when schools are not performing. We are making progress toward excellence for every child.
But the status quo always has defenders. Some want to undermine the No Child Left Behind Act by weakening standards and accountability. Yet the results we require are really a matter of common sense: We expect third graders to read and do math at third grade level - and that is not asking too much. Testing is the only way to identify and help students who are falling behind.
This Nation will not go back to the days of simply shuffling children along from grade to grade without them learning the basics. I refuse to give up on any child - and the No Child Left Behind Act is opening the door of opportunity to all of America's children.
At the same time, we must ensure that older students and adults can gain the skills they need to find work now. Many of the fastest-growing occupations require strong math and science preparation, and training beyond the high school level. So tonight I propose a series of measures called Jobs for the 21st Century. This program will provide extra help to middle- and high school students who fall behind in reading and math, expand Advanced Placement programs in low-income schools, and invite math and science professionals from the private sector to teach part-time in our high schools. I propose larger Pell Grants for students who prepare for college with demanding courses in high school. I propose increasing our support for America's fine community colleges, so they can train workers for the industries that are creating the most new jobs. By all these actions, we will help more and more Americans to join in the growing prosperity of our country.
Job training is important, and so is job creation. We must continue to pursue an aggressive, pro-growth economic agenda.
Congress has some unfinished business on the issue of taxes. The tax reductions you passed are set to expire. Unless you act, the unfair tax on marriage will go back up. Unless you act, millions of families will be charged 300 dollars more in Federal taxes for every child. Unless you act, small businesses will pay higher taxes. Unless you act, the death tax will eventually come back to life. Unless you act, Americans face a tax increase. What the Congress has given, the Congress should not take away: For the sake of job growth, the tax cuts you passed should be permanent.
Our agenda for jobs and growth must help small business owners and employees with relief from needless Federal regulation, and protect them from junk and frivolous lawsuits. Consumers and businesses need reliable supplies of energy to make our economy run - so I urge you to pass legislation to modernize our electricity system, promote conservation, and make America less dependent on foreign sources of energy. My Administration is promoting free and fair trade, to open up new markets for America's entrepreneurs, and manufacturers, and farmers, and to create jobs for America's workers. Younger workers should have the opportunity to build a nest egg by saving part of their Social Security taxes in a personal retirement account. We should make the Social Security system a source of ownership for the American people.
And we should limit the burden of government on this economy by acting as good stewards of taxpayer dollars. In two weeks, I will send you a budget that funds the war, protects the homeland, and meets important domestic needs, while limiting the growth in discretionary spending to less than four percent. This will require that Congress focus on priorities, cut wasteful spending, and be wise with the people's money. By doing so, we can cut the deficit in half over the next five years.
Tonight I also ask you to reform our immigration laws, so they reflect our values and benefit our economy. I propose a new temporary worker program to match willing foreign workers with willing employers, when no Americans can be found to fill the job. This reform will be good for our economy - because employers will find needed workers in an honest and orderly system. A temporary worker program will help protect our homeland - allowing border patrol and law enforcement to focus on true threats to our national security. I oppose amnesty, because it would encourage further illegal immigration, and unfairly reward those who break our laws. My temporary worker program will preserve the citizenship path for those who respect the law, while bringing millions of hardworking men and women out from the shadows of American life.
Our Nation's health care system, like our economy, is also in a time of change. Amazing medical technologies are improving and saving lives. This dramatic progress has brought its own challenge, in the rising costs of medical care and health insurance. Members of Congress, we must work together to help control those costs and extend the benefits of modern medicine throughout our country.
Meeting these goals requires bipartisan effort - and two months ago, you showed the way. By strengthening Medicare and adding a prescription drug benefit, you kept a basic commitment to our seniors: You are giving them the modern medicine they deserve.
Starting this year, under the law you passed, seniors can choose to receive a drug discount card, saving them 10 to 25 percent off the retail price of most prescription drugs - and millions of low-income seniors can get an additional 600 dollars to buy medicine. Beginning next year, seniors will have new coverage for preventive screenings against diabetes and heart disease, and seniors just entering Medicare can receive wellness exams.
In January of 2006, seniors can get prescription drug coverage under Medicare. For a monthly premium of about 35 dollars, most seniors who do not have that coverage today can expect to see their drug bills cut roughly in half. Under this reform, senior citizens will be able to keep their Medicare just as it is, or they can choose a Medicare plan that fits them best - just as you, as Members of Congress, can choose an insurance plan that meets your needs. And starting this year, millions of Americans will be able to save money tax-free for their medical expenses, in a health savings account.
I signed this measure proudly, and any attempt to limit the choices of our seniors, or to take away their prescription drug coverage under Medicare, will meet my veto.
On the critical issue of health care, our goal is to ensure that Americans can choose and afford private health care coverage that best fits their individual needs. To make insurance more affordable, Congress must act to address rapidly rising health care costs. Small businesses should be able to band together and negotiate for lower insurance rates, so they can cover more workers with health insurance - I urge you to pass Association Health Plans. I ask you to give lower-income Americans a refundable tax credit that would allow millions to buy their own basic health insurance. By computerizing health records, we can avoid dangerous medical mistakes, reduce costs, and improve care. To protect the doctor-patient relationship, and keep good doctors doing good work, we must eliminate wasteful and frivolous medical lawsuits. And tonight I propose that individuals who buy catastrophic health care coverage, as part of our new health savings accounts, be allowed to deduct 100 percent of the premiums from their taxes.
A government-run health care system is the wrong prescription. By keeping costs under control, expanding access, and helping more Americans afford coverage, we will preserve the system of private medicine that makes America's health care the best in the world.
We are living in a time of great change - in our world, in our economy, and in science and medicine. Yet some things endure - courage and compassion, reverence and integrity, respect for differences of faith and race. The values we try to live by never change. And they are instilled in us by fundamental institutions, such as families, and schools, and religious congregations. These institutions - the unseen pillars of civilization - must remain strong in America, and we will defend them.
We must stand with our families to help them raise healthy, responsible children. And when it comes to helping children make right choices, there is work for all of us to do.
One of the worst decisions our children can make is to gamble their lives and futures on drugs. Our government is helping parents confront this problem, with aggressive education, treatment, and law enforcement. Drug use in high school has declined by 11 percent over the past two years. Four hundred thousand fewer young people are using illegal drugs than in the year 2001. In my budget, I have proposed new funding to continue our aggressive, community-based strategy to reduce demand for illegal drugs. Drug testing in our schools has proven to be an effective part of this effort. So tonight I propose an additional 23 million dollars for schools that want to use drug testing as a tool to save children's lives. The aim here is not to punish children, but to send them this message: We love you, and we don't want to lose you.
To help children make right choices, they need good examples. Athletics play such an important role in our society, but, unfortunately, some in professional sports are not setting much of an example. The use of performance-enhancing drugs like steroids in baseball, football, and other sports is dangerous, and it sends the wrong message - that there are shortcuts to accomplishment, and that performance is more important than character. So tonight I call on team owners, union representatives, coaches, and players to take the lead, to send the right signal, to get tough, and to get rid of steroids now.
To encourage right choices, we must be willing to confront the dangers young people face - even when they are difficult to talk about. Each year, about three million teenagers contract sexually transmitted diseases that can harm them, or kill them, or prevent them from ever becoming parents. In my budget, I propose a grassroots campaign to help inform families about these medical risks. We will double Federal funding for abstinence programs, so schools can teach this fact of life: Abstinence for young people is the only certain way to avoid sexually transmitted diseases. Decisions children make now can affect their health and character for the rest of their lives. All of us - parents, schools, government - must work together to counter the negative influence of the culture, and to send the right messages to our children.
A strong America must also value the institution of marriage. I believe we should respect individuals as we take a principled stand for one of the most fundamental, enduring institutions of our civilization. Congress has already taken a stand on this issue by passing the Defense of Marriage Act, signed in 1996 by President Clinton. That statute protects marriage under Federal law as the union of a man and a woman, and declares that one state may not redefine marriage for other states. Activist judges, however, have begun redefining marriage by court order, without regard for the will of the people and their elected representatives. On an issue of such great consequence, the people's voice must be heard. If judges insist on forcing their arbitrary will upon the people, the only alternative left to the people would be the constitutional process. Our Nation must defend the sanctity of marriage.
The outcome of this debate is important - and so is the way we conduct it. The same moral tradition that defines marriage also teaches that each individual has dignity and value in God's sight.
It is also important to strengthen our communities by unleashing the compassion of America's religious institutions. Religious charities of every creed are doing some of the most vital work in our country - mentoring children, feeding the hungry, taking the hand of the lonely. Yet government has often denied social service grants and contracts to these groups, just because they have a cross or Star of David or crescent on the wall. By Executive Order, I have opened billions of dollars in grant money to competition that includes faith-based charities. Tonight I ask you to codify this into law, so people of faith can know that the law will never discriminate against them again.
In the past, we have worked together to bring mentors to the children of prisoners, and provide treatment for the addicted, and help for the homeless. Tonight I ask you to consider another group of Americans in need of help. This year, some 600,000 inmates will be released from prison back into society. We know from long experience that if they can't find work, or a home, or help, they are much more likely to commit more crimes and return to prison. So tonight, I propose a four-year, 300 million dollar Prisoner Re-Entry Initiative to expand job training and placement services, to provide transitional housing, and to help newly released prisoners get mentoring, including from faith-based groups. America is the land of the second chance - and when the gates of the prison open, the path ahead should lead to a better life.
For all Americans, the last three years have brought tests we did not ask for, and achievements shared by all. By our actions, we have shown what kind of Nation we are. In grief, we found the grace to go on. In challenge, we rediscovered the courage and daring of a free people. In victory, we have shown the noble aims and good heart of America. And having come this far, we sense that we live in a time set apart.
I have been a witness to the character of the American people, who have shown calm in times of danger, compassion for one another, and toughness for the long haul. All of us have been partners in a great enterprise. And even some of the youngest understand that we are living in historic times. Last month a girl in Lincoln, Rhode Island, sent me a letter. It began, "Dear George W. Bush." "If there is anything you know, I Ashley Pearson age 10 can do to help anyone, please send me a letter and tell me what I can do to save our country." She added this P.S.: "If you can send a letter to the troops ... please put, 'Ashley Pearson believes in you.'" Tonight, Ashley, your message to our troops has just been conveyed. And yes, you have some duties yourself. Study hard in school, listen to your mom and dad, help someone in need, and when you and your friends see a man or woman in uniform, say "thank you." And while you do your part, all of us here in this great chamber will do our best to keep you and the rest of America safe and free.
My fellow citizens, we now move forward, with confidence and faith. Our Nation is strong and steadfast. The cause we serve is right, because it is the cause of all mankind. The momentum of freedom in our world is unmistakable - and it is not carried forward by our power alone. We can trust in that greater power Who guides the unfolding of the years. And in all that is to come, we can know that His purposes are just and true.
May God bless the United States of America. Thank you.`
